Bug 1274857 - nntpsend doesn't work -- innxmit processes get killed before they are finished
nntpsend doesn't work -- innxmit processes get killed before they are finished
Status: CLOSED ERRATA
Product: Fedora EPEL
Classification: Fedora
Component: inn (Show other bugs)
epel7
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Dominik 'Rathann' Mierzejewski
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-23 13:09 EDT by Jonathan Kamens
Modified: 2016-07-20 00:49 EDT (History)
5 users (show)

See Also:
Fixed In Version: inn-2.6.0-4.fc24 inn-2.6.0-4.fc23 inn-2.5.5-1.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-07-10 01:55:50 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
nntpsend patch (594 bytes, text/plain)
2015-10-23 13:09 EDT, Jonathan Kamens
no flags Details

  None (edit)
Description Jonathan Kamens 2015-10-23 13:09:31 EDT
Created attachment 1085870 [details]
nntpsend patch

When systemd runs the innd-nntpsend service, the innxmit processes that get launched by nntpsend get killed by systemd before they are finished. Here's why...

The documentation for nntpsend claims that it waits until all of the child innxmit processes exit before it does, but it doesn't.

The reason it does not is because it starts the innxmit processes, or more accurately the subshells that start the innxmit processes, in a while loop that is itself in a child process of the main shell, because of this line:

    cat ${INPUT} | while read SITE HOST SIZE_ARG FLAGS; do

Since the while loop is in a pipe, it's executed in a child process. As a result, its child processes, i.e., the ones running innxmit, are not direct children of the nntpsend shell script's process, so it doesn't wait for them.

A trivial fix is attached.

(Also submitted to the INN maintainers, but given that this bug makes nntpsend completely note work on RHEL, I advise patching it in RHEL quickly rather than waiting for the upstream maintainers to put out a new release with the fix.)
Comment 1 Jonathan Kamens 2015-10-23 14:16:03 EDT
FYI, the INN maintainers say, "Well, many thanks for your comments and the fix.  Very much appreciated. It will be included in the next release (INN 2.6.1)."
Comment 2 Dominik 'Rathann' Mierzejewski 2016-01-21 19:05:10 EST
Could you test this scratch build once it completes?
http://koji.fedoraproject.org/koji/taskinfo?taskID=12639955
Comment 3 Jonathan Kamens 2016-01-22 14:32:07 EST
Can't unfortunately unless you do a rebuild of suck as well:

Error: Package: suck-4.3.2-39.el7.x86_64 (@epel)
           Requires: libinn.so.2()(64bit)
           Removing: inn-libs-2.5.3-18.el7.x86_64 (@epel)
               libinn.so.2()(64bit)
           Updated By: inn-libs-2.6.0-1.el7.x86_64 (/inn-libs-2.6.0-1.el7.x86_6\
4)
              ~libinn.so.3()(64bit)
Comment 4 Fedora Update System 2016-07-02 18:44:54 EDT
inn-2.5.5-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-b4ead6ec2a
Comment 5 Fedora Update System 2016-07-02 18:45:16 EDT
inn-2.6.0-4.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-3c83d0c73d
Comment 6 Fedora Update System 2016-07-02 18:45:32 EDT
inn-2.6.0-4.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-594d7ca809
Comment 7 Fedora Update System 2016-07-03 10:48:39 EDT
inn-2.5.5-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-b4ead6ec2a
Comment 8 Fedora Update System 2016-07-03 10:53:00 EDT
inn-2.6.0-4.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-594d7ca809
Comment 9 Fedora Update System 2016-07-03 11:23:10 EDT
inn-2.6.0-4.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-3c83d0c73d
Comment 10 Fedora Update System 2016-07-10 01:55:38 EDT
inn-2.6.0-4.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 11 Fedora Update System 2016-07-12 19:51:28 EDT
inn-2.6.0-4.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 12 Fedora Update System 2016-07-20 00:49:15 EDT
inn-2.5.5-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.